;***********************************************************************************************
;       "60-2"
; RB1 - output crancshaft position sensor signal
; RB0 - output for camshat position
;***********************************************************************************************
            LIST        p=16F628   ;   .
            include "p16f628A.inc"
            errorlevel  -302
            __CONFIG    3f0ah ;   , WDT ,  
                                    ;  HS.
; ""   .
;===============================================================================================
Sec         equ         70h         ;  .
ZUB         equ         71h         ;  
PAUSE1      equ         72h         ; c 
W_Temp      equ         73h         ; 
Stat_Temp   equ         74h         ; 
PCT         equ         75h         ;
V           equ         76h         ;   
SecM        equ         77h         ;  
V2          equ         78h         ;   
FIVE        equ         79h         ; 50   
edin        equ         7ah         ;    
desiat      equ         7bh         ;    
PAUSE2      equ         7ch         ;  
VI          equ         7dh         ;   BCD 
;===============================================================================================

;     .
;===============================================================================================
F           equ         1           ;    .
W           equ         0           ;   
;===============================================================================================
            org         0           ;       PC.
            goto        Start       ;    Start.
            org         4           ;     c , 
                                    ; ,  PC,    04h.
;***********************************************************************************************


;===============================================================================================
;  .
;===============================================================================================
; 
;----------------------------------------------
INT          movwf      W_Temp      ;   W   W_Temp.
             movf       PCLATH,0    ;    
             movwf      PCT         ; 
             swapf      STATUS,W    ;  /  Status.    W. 
             movwf      Stat_Temp   ;   W   Stat_temp
;-------------------------------------------------------------------------
;   0-  (       1- ?)
;-------------------------------------------------------------------------
            bcf       STATUS,RP0    ;  0- .
            btfsc     INTCON,RBIF   ; ,     
            goto      KNOPKI        ;     
  	        decfsz    ZUB,1         ;   
  	        goto      IMPULS        ;   0,   
	        decfsz    PAUSE1,1      ;   ,  (4 )
            goto      PAUSE
            movlw     .117          ;   ,
            movwf     ZUB		    ;  
			movlw     .4            ; 
			movwf     PAUSE1        ; 
            btfss     PORTB,0       ; ()  
            goto      MARC
            bcf       PORTB,0
            goto      exit	        
IMPULS      btfss     PORTB,1       ;  ,  0,
   		    goto      setb          ;  1
		    nop
  		    bcf       PORTB,1       ;  ,    0
			goto      exit
setb			
  			bsf       PORTB,1       ;   
  			goto      exit
MARC		bsf       PORTB,0
			goto      exit
PAUSE
            incf      ZUB,F     	;   !
            goto      exit
KNOPKI      call      DREBEZG
            btfsc     PORTB,7      ;   ( - 0)
            goto      MINUS        ;  ,    
            incf      V,W          ;   1
            addlw     .135         ;   120 (   ?)
            btfsc     STATUS,Z     ;  ,
            goto      VIHOD        ;  
            incf      V,F          ;  ,   
            btfss     V,0          ;   
            goto      ZEROp
            movlw     .5           ;     
            movwf     FIVE         ; 5     
            goto      TABLE
MINUS       btfsc     PORTB,6
            goto      VIHOD
            decfsz    V,W          ;  ,   0 
            goto      Minus
            goto      VIHOD        ;  0   
Minus       decf      V,F          ;  
            btfsc     V,0          ;   
            goto      ZEROm          
            clrf      FIVE
TABLE       movlw     high TIMER   ;       TIMER  w
            movwf     PCLATH       ;  W  PCLATH (    .  TIMER)
            call      TIMER        ;     
            bsf       STATUS,RP0   ; 1 
            movwf     PR2          ;      
            movlw     high Delit   ;       Delit   w
            movwf     PCLATH       ;  W  PCLATH (    .  Delit)
            call      Delit        ;     
            bcf       STATUS,RP0   ; 0 
            movwf     T2CON        ;       
; -                            
VIHOD       movf       V2,W
            movwf      VI
 		    clrf       desiat
des              ;  
            movlw     .10
            subwf      VI,W
            btfss      STATUS,C
    	    goto       ed
    	    movwf      VI
    	    incf       desiat,F
            goto       des
ed               ;  - 
    	    movf       VI,W
            movwf      edin
;  ============
;    .
;============================================================================================
KNoff       bcf        STATUS,RP0
            movf       PORTB,W     ;    B.
            andlw      b'11000000' ;   /.      
            xorlw      b'11000000' ; ,   ?
            btfss      STATUS,Z    ;  W  =0  =0 ?
            goto       KNoff       ;  =0 ( ),    
                                   ;  KNoff
            call       DREBEZG     ;  =0,    
;---->      DREBEZG  
;================================================================================
            bcf       INTCON,RBIF  ;  
            goto      exit
;              
DREBEZG     movlw     .237         ; 
            movwf     Sec          ; 
            movlw     .237         ;
            movwf     SecM         ; 
VR          decfsz    Sec,1        ; 
            goto      VR           ; 
            decfsz    SecM,1       ; 
            goto      VR           ;
            return
ZEROp       incf     V2            ; 
            clrf     FIVE          ; 
            goto     TABLE         ;    
ZEROm       decf     V2            ; "5" 
            movlw    .5            ;  
            movwf    FIVE          ; 
            goto     TABLE         ;  
exit        bcf       PIR1,TMR2IF    ;      TMR2.
;-------------------------------------------------
;    Status  W.
;------------------------------------------------- 
			movf 	   PCT,0       ;   
			movwf 	   PCLATH      ;  
            swapf      Stat_Temp,0 ;  /.    W.    
            movwf      STATUS      ;   W   Status.
            swapf      W_Temp,1    ;  /.     W_Temp.
            swapf      W_Temp,0    ;  /.    W. 
            retfie                 ;    .
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


;===============================================================================================
; " " .
;===============================================================================================
;  .
;------------------------------------
Start       clrf        INTCON      ;   
            movlw       7           ;  
            movwf       CMCON       ; .
            movlw       04h         ;  TMR2   . =16
            movwf       T2CON       ;  .  =5.(50 /)
            bsf         STATUS,RP0  ;   1- . 
            bcf         OPTION_REG,NOT_RBPU ;   
            movlw       b'11000000' ; 0,1-,8,7-()
            movwf       TRISB       ;   B 
            movlw       b'11110000'  
            movwf       TRISA 
            movlw       .49         ;  
            movwf       PR2         ;    PR2.
            bcf         STATUS,RP0
            movf        PORTB,W     ;    B(c   RBIF)
            clrf        V2
            clrf        desiat
            clrf        edin
            movlw       .1          ;    
            movwf       V
            movlw      .5
            movwf       FIVE
            movlw       .117        ; 115=582+1
			movwf       ZUB			;  	
			movlw       .4          ; 
			movwf       PAUSE1      ; (2    )
            bsf         STATUS,RP0
            movlw       b'00000010' ;  
            movwf       PIE1        ;   TMR2.
            movlw       b'11001000' ;    
            movwf       INTCON      ;     ,RB7-RB4
            bcf         STATUS,RP0  ;   0- .
; 
IND         bcf         STATUS,RP0
 			clrf        PORTA
            bcf         PORTB,2
            movf        FIVE,W
            movwf       PORTA
            call        indTIME
            clrf        PORTA
            bsf         PORTB,2
            bcf         PORTB,3
            movf        edin,W
            movwf       PORTA
            call        indTIME
            clrf        PORTA
            bsf         PORTB,3
            bcf         PORTB,4
            movf        desiat,W
            movwf       PORTA
            call        indTIME
            bsf         PORTB,4
            goto        IND
indTIME     movlw       0xff
            movwf       PAUSE2
eee         decfsz      PAUSE2,F
            goto        eee
            return       
;***********************************************************************************************
;        
;***********************************************************************************************
TIMER      movlw   high table1           ;       table1  w
           movwf   PCLATH                ;          ( 256 )     
           movf    V,w                   ;   w ( )
           addlw   low table1            ; c w    PC  table1
           btfsc   STATUS,C              ;    ()
           incf    PCLATH,1              ; , +1  PCLATH
           movf    V,w                   ;  , . .
          addwf       PCL,1              ;  PCL    W.
table1      dt        .249,.249,.124,.82,.62,.249,.207,.178,.155,.138,.124,.113,.103,.95,.88,.82
            dt        .77,.73,.68,.65,.249,.237,.226,.216,.207,.199,.191,.184,.178,.171,.166,.160
            dt        .155,.151,.146,.142,.138,.134,.131,.127,.124,.121,.118,.115,.113,.110,.108,.105
            dt        .103,.101,.99,.97,.95,.93,.92,.90,.88,.87,.85,.84,.82,.81,.80,.78
            dt        .77,.76,.75,.74,.73,.71,.70,.69,.68,.67,.67,.66,.65,.64,.63,.252
            dt        .249,.246,.243,.240,.237,.234,.232,.229,.226,.224,.221,.219,.216,.214,.212,.210
            dt        .207,.205,.203,.201,.199,.197,.195,.193,.191,.189,.188,.186,.184,.182,.181,.179
            dt        .178,.176,.174,.173,.171,.170,.168,.167,.166
Delit      movlw   high table2           ;       table2   w
           movwf   PCLATH                ;          ( 256 )     
           movf    V,w                   ;   w ( )
           addlw   low table2            ; c w    PC  table2
           btfsc   STATUS,C              ;    ()
           incf    PCLATH,1              ; , +1  PCLATH
           movf    V,w                   ;  , . .
           addwf      PCL,1              ;  PCL    W.
table2      dt        0x47,0x47,0x47,0x47,0x47,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07
            dt        0x07,0x07,0x07,0x07,0x05,0x05,0x05,0x05,0x05,0x05,0x05,0x05,0x05,0x05,0x05,0x05
            dt        0x05,0x05,0x05,0x05,0x05,0x05,0x05,0x05,0x05,0x05,0x05,0x05,0x05,0x05,0x05,0x05
            dt        0x05,0x05,0x05,0x05,0x05,0x05,0x05,0x05,0x05,0x05,0x05,0x05,0x05,0x05,0x05,0x05
            dt        0x05,0x05,0x05,0x05,0x05,0x05,0x05,0x05,0x05,0x05,0x05,0x05,0x05,0x05,0x05,0x04
            dt        0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04
            dt        0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04
            dt        0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04
            
            end                         ;  .
